import { Serializeable } from "./serializeable";

const MAX_LABEL_SIZE = 63;

export class Label implements Serializeable {
   constructor(public name?: string) { }

   public lock() {
      let parts = this.name.split(".");
      let length = 0;
      parts.forEach(e => {
         if (e.length > MAX_LABEL_SIZE) throw new Error("Label to large");
         length += e.length + 1;
      })

      length += 1;
      return {
         length: length,
         serialize: (buffer: Buffer, offset: number) => {
            parts.forEach(e => {
               buffer.writeUInt8(e.length, offset)
               offset++
               buffer.write(e, offset, e.length)
               offset += e.length
            })
            buffer.writeUInt8(0, offset);
            offset += 1;
            return offset;
         }
      }
   }

   // set name(name: string) {
   //    if (name != this._name) {
   //       let length = 0;
   //       let parts = name.split(".")
   //       parts.forEach(e => {
   //          if (e.length > MAX_LABEL_SIZE) throw new Error("Label to large");
   //          length += e.length + 1;
   //       })

   //       length += 1; //Adding last 0 length octet
   //       this._length = length;
   //       this._name_parts = parts;
   //       this._name = name;
   //    }
   // }

   // get name() {
   //    return this._name;
   // }

   // get length() {
   //    return this._length;
   // }

   // serialize(buffer: Buffer, offset: number) {

   // }
}